DevExtreme v23.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Menu

Populate Menu with Data and Configure the Access to It

You can display Menu items from the items array or a dataSource. This demo contains an example of a data structure. If you use a dataSource, specify the displayExpr property.

To access the clicked item, use the onItemClick event handler function.

Configure the Menu

Use the orientation property to specify whether the Menu has horizontal or vertical orientation. Use the animation property to specify the type, delay, duration, and other options of show and hide menu actions.

Configure the Submenus

Clicking or a hovering a Menu item opens a drop-down menu that can contain several submenus. To specify the drop-down menu mode ("onClick" or "onHover"), use the showSubmenuMode property. If you need only to specify the first level of drop-down menus, use the showFirstSubmenuMode property.

If you want to hide the submenu when the mouse pointer leaves it, set the hideSubmenuOnMouseLeave property to true.

Customize Item Appearance

You can define specific fields in the item data objects to change the appearance of an item. For example, use the icon property to supply items with icons. Define an itemTemplate to customize item appearance.

Backend API
$(() => { const dxMenu = $('#menu').dxMenu({ dataSource: menuData, hideSubmenuOnMouseLeave: false, displayExpr: 'name', onItemClick(data) { const item = data.itemData; if (item.price) { $('#product-details').removeClass('hidden'); $('#product-details > img').attr('src', item.icon); $('#product-details > .price').text(`$${item.price}`); $('#product-details > .name').text(item.name); } }, }).dxMenu('instance'); const showSubmenuModes = [{ name: 'onHover', delay: { show: 0, hide: 500 }, }, { name: 'onClick', delay: { show: 0, hide: 300 }, }]; $('#show-submenu-mode').dxSelectBox({ items: showSubmenuModes, value: showSubmenuModes[1], inputAttr: { 'aria-label': 'Submenu Mode' }, displayExpr: 'name', onValueChanged(data) { dxMenu.option('showFirstSubmenuMode', data.value); }, }); $('#orientation').dxSelectBox({ items: ['horizontal', 'vertical'], inputAttr: { 'aria-label': 'Orientation' }, value: 'horizontal', onValueChanged(data) { dxMenu.option('orientation', data.value); }, }); $('#mouse-leave').dxCheckBox({ value: false, text: 'Hide Submenu on Mouse Leave', onValueChanged(data) { dxMenu.option('hideSubmenuOnMouseLeave', data.value); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.2.6/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="form"> <div> <div class="label">Catalog:</div> <div id="menu"></div> <div id="product-details" class="hidden"> <img src="" /> <div class="name"></div> <div class="price"></div> </div> </div> <div class="options"> <div class="caption">Options</div> <div class="option"> <div>Show First Submenu Mode</div> <div id="show-submenu-mode"></div> </div> <div class="option"> <div>Orientation</div> <div id="orientation"></div> </div> <div class="option"> <div id="mouse-leave"></div> </div> </div> </div> </div> </body> </html>
.form { margin-left: 3px; } .form > div:first-child { margin-right: 320px; } .label { font-size: 22px; padding-bottom: 24px; } #product-details { width: 400px; height: 400px; margin: 20px auto 0; } #product-details > img { height: 300px; width: 400px; } #product-details > .name { text-align: center; font-size: 20px; } #product-details > .price { text-align: center; font-size: 24px; } .dark #product-details > div { color: #f0f0f0; } .options { padding: 20px; position: absolute; bottom: 0; right: 0; width: 260px; top: 0; background-color: rgba(191, 191, 191, 0.15); } .caption { font-size: 18px; font-weight: 500; } .option { margin-top: 10px; } .hidden { visibility: hidden; }
const menuData = [{ id: '1', name: 'Video Players', items: [{ id: '1_1', name: 'HD Video Player', price: 220, icon: '../../../../images/products/1.png', }, { id: '1_2', name: 'SuperHD Video Player', icon: '../../../../images/products/2.png', price: 270, }], }, { id: '2', name: 'Televisions', items: [{ id: '2_1', name: 'SuperLCD 42', icon: '../../../../images/products/7.png', price: 1200, }, { id: '2_2', name: 'SuperLED 42', icon: '../../../../images/products/5.png', price: 1450, }, { id: '2_3', name: 'SuperLED 50', icon: '../../../../images/products/4.png', price: 1600, }, { id: '2_4', name: 'SuperLCD 55 (Not available)', icon: '../../../../images/products/6.png', price: 1350, disabled: true, }, { id: '2_5', name: 'SuperLCD 70', icon: '../../../../images/products/9.png', price: 4000, }], }, { id: '3', name: 'Monitors', items: [{ id: '3_1', name: '19"', items: [{ id: '3_1_1', name: 'DesktopLCD 19', icon: '../../../../images/products/10.png', price: 160, }], }, { id: '3_2', name: '21"', items: [{ id: '3_2_1', name: 'DesktopLCD 21', icon: '../../../../images/products/12.png', price: 170, }, { id: '3_2_2', name: 'DesktopLED 21', icon: '../../../../images/products/13.png', price: 175, }], }], }, { id: '4', name: 'Projectors', items: [{ id: '4_1', name: 'Projector Plus', icon: '../../../../images/products/14.png', price: 550, }, { id: '4_2', name: 'Projector PlusHD', icon: '../../../../images/products/15.png', price: 750, }], }];

<div class="form">
<div>
<div class="label">Catalog:</div>
<dx-menu
#menu
[dataSource]="products"
displayExpr="name"
[showFirstSubmenuMode]="showFirstSubmenuModes"
orientation="horizontal"
[hideSubmenuOnMouseLeave]="false"
(onItemClick)="itemClick($event)"
>
</dx-menu>
@if (currentProduct) {
<div id="product-details">
<img src="{{ currentProduct.icon }}" />
<div class="name">{{ currentProduct.name }}</div>
<div class="price">{{ "$" + currentProduct.price }}</div>
</div>
}
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div>Show First Submenu Mode</div>
<dx-select-box
[items]="showSubmenuModes"
[inputAttr]="{ 'aria-label': 'Submenu Mode' }"
displayExpr="name"
[(value)]="showFirstSubmenuModes"
></dx-select-box>
</div>
<div class="option">
<div>Orientation</div>
<dx-select-box
[items]="['horizontal', 'vertical']"
[inputAttr]="{ 'aria-label': 'Orientation' }"
[(value)]="menu.orientation"
></dx-select-box>
</div>
<div class="option">
<dx-check-box
text="Hide Submenu on Mouse Leave"
[(value)]="menu.hideSubmenuOnMouseLeave"
></dx-check-box>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxSelectBoxModule, DxCheckBoxModule } from 'devextreme-angular';
import { DxMenuModule, type DxMenuTypes } from 'devextreme-angular/ui/menu';
import { Service, type Product, type ProductItem } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
const isProductItem = (item: Product | ProductItem): item is ProductItem =>
!('items' in item);
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxMenuModule,
DxSelectBoxModule,
DxCheckBoxModule,
],
})
export class AppComponent {
products: Product[];
showSubmenuModes = [{
name: 'onHover' as DxMenuTypes.SubmenuShowMode,
delay: { show: 0, hide: 500 },
}, {
name: 'onClick' as DxMenuTypes.SubmenuShowMode,
delay: { show: 0, hide: 300 },
}];
showFirstSubmenuModes = this.showSubmenuModes[1];
currentProduct: ProductItem;
constructor(service: Service) {
this.products = service.getProducts();
}
itemClick(data: DxMenuTypes.ItemClickEvent<Product>) {
const item = data.itemData;
if (isProductItem(item)) {
this.currentProduct = item;
}
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.form {
margin-left: 3px;
}
::ng-deep .form > div:first-child {
margin-right: 320px;
}
.label {
font-size: 22px;
padding-bottom: 24px;
}
::ng-deep #product-details {
margin: 20px auto 0;
width: 400px;
height: 400px;
}
::ng-deep #product-details > img {
height: 300px;
width: 400px;
}
::ng-deep #product-details > .name {
text-align: center;
font-size: 20px;
}
::ng-deep #product-details > .price {
text-align: center;
font-size: 24px;
}
::ng-deep .dark #product-details > div {
color: #f0f0f0;
}
.options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
::ng-deep .hidden {
visibility: hidden;
}
import { Injectable } from '@angular/core';
export class ProductItem {
id: string;
name: string;
icon: string;
price: number;
disabled?: boolean;
}
export class Product {
id: string;
name: string;
items: (Product | ProductItem)[];
}
const products: Product[] = [{
id: '1',
name: 'Video Players',
items: [{
id: '1_1',
name: 'HD Video Player',
price: 220,
icon: '../../../../images/products/1.png',
}, {
id: '1_2',
name: 'SuperHD Video Player',
icon: '../../../../images/products/2.png',
price: 270,
}],
}, {
id: '2',
name: 'Televisions',
items: [{
id: '2_1',
name: 'SuperLCD 42',
icon: '../../../../images/products/7.png',
price: 1200,
}, {
id: '2_2',
name: 'SuperLED 42',
icon: '../../../../images/products/5.png',
price: 1450,
}, {
id: '2_3',
name: 'SuperLED 50',
icon: '../../../../images/products/4.png',
price: 1600,
}, {
id: '2_4',
name: 'SuperLCD 55 (Not available)',
icon: '../../../../images/products/6.png',
price: 1350,
disabled: true,
}, {
id: '2_5',
name: 'SuperLCD 70',
icon: '../../../../images/products/9.png',
price: 4000,
}],
}, {
id: '3',
name: 'Monitors',
items: [{
id: '3_1',
name: '19"',
items: [{
id: '3_1_1',
name: 'DesktopLCD 19',
icon: '../../../../images/products/10.png',
price: 160,
}],
}, {
id: '3_2',
name: '21"',
items: [{
id: '3_2_1',
name: 'DesktopLCD 21',
icon: '../../../../images/products/12.png',
price: 170,
}, {
id: '3_2_2',
name: 'DesktopLED 21',
icon: '../../../../images/products/13.png',
price: 175,
}],
}],
}, {
id: '4',
name: 'Projectors',
items: [{
id: '4_1',
name: 'Projector Plus',
icon: '../../../../images/products/14.png',
price: 550,
}, {
id: '4_2',
name: 'Projector PlusHD',
icon: '../../../../images/products/15.png',
price: 750,
}],
}];
@Injectable()
export class Service {
getProducts(): Product[] {
return products;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.25/package.json',
'npm:devexpress-gantt@4.1.67/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.7"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

If you have technical questions, please create a support ticket in the DevExpress Support Center.
import React, { useCallback, useState } from 'react';
import Menu, { MenuTypes } from 'devextreme-react/menu';
import SelectBox, { SelectBoxTypes } from 'devextreme-react/select-box';
import CheckBox, { CheckBoxTypes } from 'devextreme-react/check-box';
import service, { ProductItemType } from './data.ts';
const orientations = ['horizontal', 'vertical'];
const orientationLabel = { 'aria-label': 'Orientation' };
const showSubmenuModeLabel = { 'aria-label': 'Show Submenu Mode' };
const products = service.getProducts();
interface showSubmenuModesType {
name: MenuTypes.SubmenuShowMode,
delay: {
show: number,
hide: number
}
}
const showSubmenuModes: showSubmenuModesType[] = [
{
name: 'onHover',
delay: { show: 0, hide: 500 },
},
{
name: 'onClick',
delay: { show: 0, hide: 300 },
},
];
const App = () => {
const [showFirstSubmenuModes, setShowFirstSubmenuModes] = useState(showSubmenuModes[1]);
const [orientation, setOrientation] = useState<MenuTypes.Orientation>('horizontal');
const [hideSubmenuOnMouseLeave, setHideSubmenuOnMouseLeave] = useState(false);
const [currentProduct, setCurrentProduct] = useState(null);
const itemClick = useCallback((e: MenuTypes.ItemClickEvent & { itemData: ProductItemType }) => {
if (e.itemData.price) {
setCurrentProduct(e.itemData);
}
}, [setCurrentProduct]);
const showSubmenuModeChanged = useCallback((e: SelectBoxTypes.ValueChangedEvent) => {
setShowFirstSubmenuModes(e.value);
}, [setShowFirstSubmenuModes]);
const orientationChanged = useCallback((e: SelectBoxTypes.ValueChangedEvent) => {
setOrientation(e.value);
}, [setOrientation]);
const hideSubmenuOnMouseLeaveChanged = useCallback((e: CheckBoxTypes.ValueChangedEvent) => {
setHideSubmenuOnMouseLeave(e.value);
}, [setHideSubmenuOnMouseLeave]);
return (
<div className="form">
<div>
<div className="label">Catalog:</div>
<Menu
dataSource={products}
displayExpr="name"
showFirstSubmenuMode={showFirstSubmenuModes}
orientation={orientation}
hideSubmenuOnMouseLeave={hideSubmenuOnMouseLeave}
onItemClick={itemClick}
/>
{currentProduct && (
<div id="product-details">
<img src={currentProduct.icon} />
<div className="name">{currentProduct.name}</div>
<div className="price">{`$${currentProduct.price}`}</div>
</div>
)}
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<div>Show First Submenu Mode</div>
<SelectBox
items={showSubmenuModes}
displayExpr="name"
inputAttr={showSubmenuModeLabel}
value={showFirstSubmenuModes}
onValueChanged={showSubmenuModeChanged}
/>
</div>
<div className="option">
<div>Orientation</div>
<SelectBox
items={orientations}
inputAttr={orientationLabel}
value={orientation}
onValueChanged={orientationChanged}
/>
</div>
<div className="option">
<CheckBox
text="Hide Submenu on Mouse Leave"
value={hideSubmenuOnMouseLeave}
onValueChanged={hideSubmenuOnMouseLeaveChanged}
/>
</div>
</div>
</div>
);
};
export default App;
xxxxxxxxxx
import React, { useCallback, useState } from 'react';
import Menu from 'devextreme-react/menu';
import SelectBox from 'devextreme-react/select-box';
import CheckBox from 'devextreme-react/check-box';
import service from './data.js';
const orientations = ['horizontal', 'vertical'];
const orientationLabel = { 'aria-label': 'Orientation' };
const showSubmenuModeLabel = { 'aria-label': 'Show Submenu Mode' };
const products = service.getProducts();
const showSubmenuModes = [
{
name: 'onHover',
delay: { show: 0, hide: 500 },
},
{
name: 'onClick',
delay: { show: 0, hide: 300 },
},
];
const App = () => {
const [showFirstSubmenuModes, setShowFirstSubmenuModes] = useState(showSubmenuModes[1]);
const [orientation, setOrientation] = useState('horizontal');
const [hideSubmenuOnMouseLeave, setHideSubmenuOnMouseLeave] = useState(false);
const [currentProduct, setCurrentProduct] = useState(null);
const itemClick = useCallback(
(e) => {
if (e.itemData.price) {
setCurrentProduct(e.itemData);
}
},
[setCurrentProduct],
);
const showSubmenuModeChanged = useCallback(
(e) => {
setShowFirstSubmenuModes(e.value);
},
[setShowFirstSubmenuModes],
);
const orientationChanged = useCallback(
(e) => {
setOrientation(e.value);
},
[setOrientation],
);
const hideSubmenuOnMouseLeaveChanged = useCallback(
(e) => {
setHideSubmenuOnMouseLeave(e.value);
},
[setHideSubmenuOnMouseLeave],
);
return (
<div className="form">
<div>
<div className="label">Catalog:</div>
<Menu
dataSource={products}
displayExpr="name"
showFirstSubmenuMode={showFirstSubmenuModes}
orientation={orientation}
hideSubmenuOnMouseLeave={hideSubmenuOnMouseLeave}
onItemClick={itemClick}
/>
{currentProduct && (
<div id="product-details">
<img src={currentProduct.icon} />
<div className="name">{currentProduct.name}</div>
<div className="price">{`$${currentProduct.price}`}</div>
</div>
)}
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<div>Show First Submenu Mode</div>
<SelectBox
items={showSubmenuModes}
displayExpr="name"
inputAttr={showSubmenuModeLabel}
value={showFirstSubmenuModes}
onValueChanged={showSubmenuModeChanged}
/>
</div>
<div className="option">
<div>Orientation</div>
<SelectBox
items={orientations}
inputAttr={orientationLabel}
value={orientation}
onValueChanged={orientationChanged}
/>
</div>
<div className="option">
<CheckBox
text="Hide Submenu on Mouse Leave"
value={hideSubmenuOnMouseLeave}
onValueChanged={hideSubmenuOnMouseLeaveChanged}
/>
</div>
</div>
</div>
);
};
export default App;
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
xxxxxxxxxx
const products = [{
id: '1',
name: 'Video Players',
items: [{
id: '1_1',
name: 'HD Video Player',
price: 220,
icon: 'images/products/1.png',
}, {
id: '1_2',
name: 'SuperHD Video Player',
icon: 'images/products/2.png',
price: 270,
}],
}, {
id: '2',
name: 'Televisions',
items: [{
id: '2_1',
name: 'SuperLCD 42',
icon: 'images/products/7.png',
price: 1200,
}, {
id: '2_2',
name: 'SuperLED 42',
icon: 'images/products/5.png',
price: 1450,
}, {
id: '2_3',
name: 'SuperLED 50',
icon: 'images/products/4.png',
price: 1600,
}, {
id: '2_4',
name: 'SuperLCD 55 (Not available)',
icon: 'images/products/6.png',
price: 1350,
disabled: true,
}, {
id: '2_5',
name: 'SuperLCD 70',
icon: 'images/products/9.png',
price: 4000,
}],
}, {
id: '3',
name: 'Monitors',
items: [{
id: '3_1',
name: '19"',
items: [{
id: '3_1_1',
name: 'DesktopLCD 19',
icon: 'images/products/10.png',
price: 160,
}],
}, {
id: '3_2',
name: '21"',
items: [{
id: '3_2_1',
name: 'DesktopLCD 21',
icon: 'images/products/12.png',
price: 170,
}, {
id: '3_2_2',
name: 'DesktopLED 21',
icon: 'images/products/13.png',
price: 175,
}],
}],
}, {
id: '4',
name: 'Projectors',
items: [{
id: '4_1',
name: 'Projector Plus',
icon: 'images/products/14.png',
price: 550,
}, {
id: '4_2',
name: 'Projector PlusHD',
icon: 'images/products/15.png',
price: 750,
}],
}];
export interface ProductItemType {
id: string,
name: string,
price: number,
icon: string,
}
export interface ProductType {
id: string,
name: string,
items: (ProductItemType | ProductType)[],
}
export default {
getProducts(): ProductType[] {
return products;
},
};
xxxxxxxxxx
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
'bundles:': 'bundles/',
'externals:': 'bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.5/cjs',
'devextreme-react': 'npm:devextreme-react@24.2.5/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.15/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.59/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
xxxxxxxxxx
const products = [
{
id: '1',
name: 'Video Players',
items: [
{
id: '1_1',
name: 'HD Video Player',
price: 220,
icon: 'images/products/1.png',
},
{
id: '1_2',
name: 'SuperHD Video Player',
icon: 'images/products/2.png',
price: 270,
},
],
},
{
id: '2',
name: 'Televisions',
items: [
{
id: '2_1',
name: 'SuperLCD 42',
icon: 'images/products/7.png',
price: 1200,
},
{
id: '2_2',
name: 'SuperLED 42',
icon: 'images/products/5.png',
price: 1450,
},
{
id: '2_3',
name: 'SuperLED 50',
icon: 'images/products/4.png',
price: 1600,
},
{
id: '2_4',
name: 'SuperLCD 55 (Not available)',
icon: 'images/products/6.png',
price: 1350,
disabled: true,
},
{
id: '2_5',
name: 'SuperLCD 70',
icon: 'images/products/9.png',
price: 4000,
},
],
},
{
id: '3',
name: 'Monitors',
items: [
{
id: '3_1',
name: '19"',
items: [
{
id: '3_1_1',
name: 'DesktopLCD 19',
icon: 'images/products/10.png',
price: 160,
},
],
},
{
id: '3_2',
name: '21"',
items: [
{
id: '3_2_1',
name: 'DesktopLCD 21',
icon: 'images/products/12.png',
price: 170,
},
{
id: '3_2_2',
name: 'DesktopLED 21',
icon: 'images/products/13.png',
price: 175,
},
],
},
],
},
{
id: '4',
name: 'Projectors',
items: [
{
id: '4_1',
name: 'Projector Plus',
icon: 'images/products/14.png',
price: 550,
},
{
id: '4_2',
name: 'Projector PlusHD',
icon: 'images/products/15.png',
price: 750,
},
],
},
];
export default {
getProducts() {
return products;
},
};
xxxxxxxxxx
<html lang="en">
<head></head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
xxxxxxxxxx
.form {
margin-left: 3px;
}
.form > div:first-child {
margin-right: 320px;
}
.label {
font-size: 22px;
padding-bottom: 24px;
}
#product-details {
width: 400px;
height: 400px;
margin: 20px auto 0;
}
#product-details > img {
height: 300px;
width: 400px;
}
#product-details > .name {
text-align: center;
font-size: 20px;
}
#product-details > .price {
text-align: center;
font-size: 24px;
}
.dark #product-details > div {
color: #f0f0f0;
}
.options {
padding: 20px;
position: absolute;
bottom: 0;
right: 0;
width: 260px;
top: 0;
background-color: rgba(191, 191, 191, 0.15);
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
}
.hidden {
visibility: hidden;
}
Configure the Menu
Use the orientation property to specify whether the Menu has horizontal or vertical orientation. Use the animation property to specify the type, delay, duration, and other options of show and hide menu actions.
Configure the Submenus
Clicking or a hovering a Menu item opens a drop-down menu that can contain several submenus. To specify the drop-down menu mode ("onClick" or "onHover"), use the showSubmenuMode property. If you need only to specify the first level of drop-down menus, use the showFirstSubmenuMode property.
If you want to hide the submenu when the mouse pointer leaves it, set the hideSubmenuOnMouseLeave property to true.
Customize Item Appearance
You can define specific fields in the item data objects to change the appearance of an item. For example, use the icon property to supply items with icons. Define an itemTemplate to customize item appearance.